/***********************************************************************/
/*                                                                     */
/*  FILE        :testt.c                                               */
/*  DATE        :Thu, Aug 23, 2012                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :RX62T                                                 */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.53).    */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
                  
#include "iodefine.h"
#include <machine.h>
#include "iolib.h"

static int  _inv_peak     = 2000;
static int  _inv_hpeak    = 1000;
static int  _inv_deadtime = 150;

void  inverter_init(int fs, int dt, int deci )
{
    int    i_period;

    i_period     = (int)((48000000.0f)/(fs) - 1);
    _inv_deadtime = (int)(96.0/1000.0*((float)dt));

    _inv_peak   = i_period - _inv_deadtime - _inv_deadtime;
    _inv_hpeak  = _inv_peak>>1;

    IOPORT.PFDGPT.BIT.GPTS = 0;

    GPT.GTSTR.BIT.CST0 = 0;
    GPT.GTSTR.BIT.CST1 = 0;
    GPT.GTSTR.BIT.CST2 = 0;

    GPT0.GTCR.BIT.MD   = 4;        /* OpovlJ16bit */
    GPT1.GTCR.BIT.MD   = 4;        /* OpovlJ16bit */
    GPT2.GTCR.BIT.MD   = 4;        /* OpovlJ16bit */

    GPT0.GTCR.BIT.TPCS = 0;        /* CLK ? */
    GPT1.GTCR.BIT.TPCS = 0;        /* CLK ? */
    GPT2.GTCR.BIT.TPCS = 0;        /* CLK ? */

    GPT0.GTPR = i_period;          /* 1/2 PWM */
    GPT1.GTPR = i_period;          /* 1/2 PWM */
    GPT2.GTPR = i_period;          /* 1/2 PWM */

    GPT0.GTCNT = 0;
    GPT1.GTCNT = 0;
    GPT2.GTCNT = 0;

    GPT0.GTDTCR.BIT.TDE   = 1;     /* fbh^Ct */
    GPT0.GTDTCR.BIT.TDBUE = 1;
    GPT0.GTDTCR.BIT.TDBDE = 1;
    GPT0.GTDTCR.BIT.TDFER = 1;
    GPT1.GTDTCR.BIT.TDE   = 1;     /* fbh^Ct */
    GPT1.GTDTCR.BIT.TDBUE = 1;
    GPT1.GTDTCR.BIT.TDBDE = 1;
    GPT1.GTDTCR.BIT.TDFER = 1;
    GPT2.GTDTCR.BIT.TDE   = 1;     /* fbh^Ct */
    GPT2.GTDTCR.BIT.TDBUE = 1;
    GPT2.GTDTCR.BIT.TDBDE = 1;
    GPT2.GTDTCR.BIT.TDFER = 1;

    GPT0.GTIOR.BIT.GTIOA = 0x03;   /* ?? pin function */
    GPT0.GTIOR.BIT.GTIOB = 0x13;   /* ?? pin function */
    GPT1.GTIOR.BIT.GTIOA = 0x03;   /* ?? pin function */
    GPT1.GTIOR.BIT.GTIOB = 0x13;   /* ?? pin function */
    GPT2.GTIOR.BIT.GTIOA = 0x03;   /* ?? pin function */
    GPT2.GTIOR.BIT.GTIOB = 0x13;   /* ?? pin function */

    GPT0.GTONCR.BIT.OAE = 1;       /* ?? o͋ */
    GPT0.GTONCR.BIT.OBE = 1;       /* ?? o͋ */
    GPT1.GTONCR.BIT.OAE = 1;       /* ?? o͋ */
    GPT1.GTONCR.BIT.OBE = 1;       /* ?? o͋ */
    GPT2.GTONCR.BIT.OAE = 1;       /* ?? o͋ */
    GPT2.GTONCR.BIT.OBE = 1;       /* ?? o͋ */

    GPT0.GTBER.BIT.CCRA = 1;       /* Buffer */
    GPT0.GTBER.BIT.CCRB = 1;       /* Buffer */
    GPT1.GTBER.BIT.CCRA = 1;       /* Buffer */
    GPT1.GTBER.BIT.CCRB = 1;       /* Buffer */
    GPT2.GTBER.BIT.CCRA = 1;       /* Buffer */
    GPT2.GTBER.BIT.CCRB = 1;       /* Buffer */

    GPT0.GTCCRA = i_period/2;
    GPT0.GTCCRC = i_period/2;
    GPT0.GTDVU  = _inv_deadtime;
    GPT0.GTDVD  = _inv_deadtime;
    GPT0.GTDBU  = _inv_deadtime;
    GPT0.GTDBD  = _inv_deadtime;
    GPT1.GTCCRA = i_period/2;
    GPT1.GTCCRC = i_period/2;
    GPT1.GTDVU  = _inv_deadtime;
    GPT1.GTDVD  = _inv_deadtime;
    GPT1.GTDBU  = _inv_deadtime;
    GPT1.GTDBD  = _inv_deadtime;
    GPT2.GTCCRA = i_period/2;
    GPT2.GTCCRC = i_period/2;
    GPT2.GTDVU  = _inv_deadtime;
    GPT2.GTDVD  = _inv_deadtime;
    GPT2.GTDBU  = _inv_deadtime;
    GPT2.GTDBD  = _inv_deadtime;

    GPT.GTSTR.WORD = 7;
}



void  inverter_set_uvw(float u, float v, float w)
{
    int   itemp;

    itemp = (int) ((-u+1.0)*((float)_inv_hpeak)+((float)_inv_deadtime));
    if (itemp>_inv_peak)  {  itemp = _inv_peak;  }
    else if (itemp<0)     {  itemp = 0;         }
    else                  { /* no code */ }
    GPT0.GTCCRC = itemp;

#if 1
    itemp = (int) ((-v+1.0)*((float)_inv_hpeak)+((float)_inv_deadtime));
    if (itemp>_inv_peak)  {  itemp = _inv_peak;  }
    else if (itemp<0)     {  itemp = 0;         }
    else                  { /* no code */ }
    GPT1.GTCCRC = itemp;

    itemp = (int) ((-w+1.0)*((float)_inv_hpeak)+((float)_inv_deadtime));
    if (itemp>_inv_peak)  {  itemp = _inv_peak;  }
    else if (itemp<0)     {  itemp = 0;         }
    else                  { /* no code */ }
    GPT2.GTCCRC = itemp;
#endif
}

void  inverter_start_int(void)
{
    GPT0.GTINTAD.BIT.GTINTPR = 2;  /* J荞 */
	/* GPT0 GTCIV0 178 */
    ICU.IER[0x16].BIT.IEN2  = 1;
	ICU.IPR[0x69].BIT.IPR = 3;
}


void  inverter_stop_int(void)
{
    GPT0.GTINTAD.BIT.GTINTPR = 0;  /* ֎~ */
}



